using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using NationalInstruments.VisaNS;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            MessageBasedSession mbSession;
            string s;
            string responseString;
            int cnt = 0;

            Console.WriteLine("\n ###########   Start Visual Studio 2005 C Sharp Example   ###########");
            Console.WriteLine(" This Example check the Multimeter M3500A On USB port and");
            Console.WriteLine(" identify the first connected DMM device, configure the DMM functions.\n");

            try
            {
                cnt = ResourceManager.GetLocalManager().FindResources("USB0::0x164E::0x0DAD::?*").Length;
            }
            catch (Exception ex)
            {
                Console.WriteLine (ex.Message);
                return;
            }

            string[] resources = ResourceManager.GetLocalManager().FindResources("USB0::0x164E::0x0DAD::?*");
            //
            // Assign the first device for the test device
            s = resources [0];
            mbSession = (MessageBasedSession)ResourceManager.GetLocalManager().Open(s);

            //
            // Send command "*idn?" and read the identification string
            mbSession.Write("*idn?");
            Thread.Sleep(200);
            responseString = mbSession.ReadString();
            Console.WriteLine(" Query *idn? :");
            Console.WriteLine(" --> " + responseString);
            //
            // Set the sample count to 1
            mbSession.Write("SAMP:COUN 1");
            Console.WriteLine(" --> Set the sample count = 1");
            Thread.Sleep(1000);
            // Set configure function VOLTage AC, range 10
            mbSession.Write("CONF:VOLT:AC 10,0.01");
            Console.WriteLine(" --> Set the configure function VOLTage AC, range 0.1");
            Thread.Sleep(2000);
            // Set configure function FREQuency
            mbSession.Write("CONF:FREQ");
            Console.WriteLine(" --> Set the configure function FREQuency");
            Thread.Sleep(2000);
            // Set configure function CURRent DC, range 1
            mbSession.Write("CONF:CURR:DC 0.1,0.01");
            Console.WriteLine(" --> Set the configure function CURRent DC, range 1");
            Thread.Sleep(1000);
            // Set configure function VOLTage DC, range 0.1
            mbSession.Write("CONF:VOLT:DC 1,0.1");
            Console.WriteLine(" --> Set the configure function VOLTage DC, range 0.1");
            Thread.Sleep(1000);
            // Read the measurement
            mbSession.Write("read?");
            Thread.Sleep(200);
            responseString = mbSession.ReadString();
            Console.WriteLine(" Read in the measurement :");
            Console.WriteLine(" --> " + responseString);

            // Set the M3500A to local mode
            mbSession.Write("system:local");
            mbSession.Dispose();
            Console.WriteLine(" Press any key ...");
            Console.ReadLine();
            return;

        }
    }
}
